`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 04/06/2020 10:48:12 AM
// Design Name: 
// Module Name: Lab6_3
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab6_3(
    setting,
    f_crystal,
    reset,
    pb1,
    pb2,
    set_state,
    mode_state,
    ssd_ctl,
    D_ssd,
    Lap6_1_LED,
    state6_1_LED,
    start_LED6_2,
    count_LED6_2,
    LED
    );
    input pb1, pb2;
    input reset, setting, f_crystal;
    output set_state, mode_state;
    output Lap6_1_LED, state6_1_LED;
    output start_LED6_2, count_LED6_2;
    output [9:0]LED;
    output [3:0]ssd_ctl;
    output reg [7:0]D_ssd;
    wire [7:0]D_ssd_1, D_ssd_2;
    wire [3:0]ssd_ctl_useless;
    wire set_enable;
    wire clk_1, clk_10, clk_100;
    wire [1:0]ssd_clk;
    wire setting_deb_out, setting_oneP_out;
    wire mode_oneP_out;
    wire Longout;
    
    //  The following variable is for MUX module
    wire start6_1, Lap6_1;
    wire start_or_set6_2, pause_or_set6_2;
    
    frq_div U0(
    .f_out(clk_1), // divided clock output
    .clk_100(clk_100),
    .clk_10(clk_10),
    .ssd_clk(ssd_clk),
    .f_crystal(f_crystal), // global clock input
    .rst(reset) // active low reset
    );
    debounce U_setting(
      .clk(clk_100), // clock control
      .rst(reset), // reset
      .pb_in(setting), //push button input
      .pb_debounced(setting_deb_out) // debounced push button output
    );
    one_pulse U_seeing(
      .clk(clk_1),  // clock input
      .rst(reset), //active low reset
      .in_trig(setting_deb_out), // input trigger
      .out_pulse(setting_oneP_out) // output one pulse 
    );
    set_FSM U_setFSM(
    .count_enable(set_enable), // if counter is enabled
    .in(setting_oneP_out), //input control
    .clk(clk_1), // global clock signal
    .rst(reset), // high active reset
    .state(set_state)
    );
    Long_press U1(
    .in(setting_deb_out),
    .clk(f_crystal),
    .rst(Longout)
    );
    one_pulse U_mode_oneP(
        .clk(clk_1),  // clock input
        .rst(reset), //active low reset
        .in_trig(Longout), // input trigger
        .out_pulse(mode_oneP_out) // output one pulse 
     );
     FSM U_mode_FSM(
     .in(mode_oneP_out), //input control
     .clk(clk_1), // global clock signal
     .rst(reset), // high active reset
     .state(mode_state)
     );
      MUX U2(
        .pb1(pb1),
        .pb2(pb2),
        .state(mode_state),
        .start6_1(start6_1),
        .Lap6_1(Lap6_1),
        .start_or_min6_2(start_or_set6_2),
        .pause_or_sec6_2(pause_or_set6_2)
        );
      Lab6_1 U3(
    .ssd_clk(ssd_clk),
    .clk_1(clk_1),
    .clk_100(clk_100),
    .clk_10(clk_10),
    .rst(reset),
    .mode_in(Lap6_1),
    .state_in(start6_1),
    .state_LED(state6_1_LED),
    .mode_LED(Lap6_1_LED),
    .ssd_ctl(ssd_ctl),
    .D_ssd(D_ssd_1)
    );
    Lab6_2 U4(
    .clk_1(clk_1),
    .clk_10(clk_10),
    .clk_100(clk_100),
    .pause_pb(pause_or_set6_2),
    .stop_pb(start_or_set6_2),
    .state_LED(count_LED6_2),
    .mode_LED(start_LED6_2),
    .ssd_ctl(ssd_ctl_useless), //useless
    .D_ssd(D_ssd_2),
    .ssd_clk(ssd_clk),
    .LED(LED),
    .setting(set_enable),
    .rst(reset),
    .mode6_1_or_6_2(mode_state)
    );
    
    always @*
        if(mode_state == 0)
            D_ssd = D_ssd_1;
        else
            D_ssd = D_ssd_2;
    
endmodule
