`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/30/2020 03:10:47 PM
// Design Name: 
// Module Name: Lab5_3
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab6_1(
    ssd_clk,
    clk_1,
    clk_100,
    clk_10,
    rst,
    mode_in,
    state_in,
    state_LED,
    mode_LED,
    ssd_ctl,
    D_ssd
    );
    
    input [1:0]ssd_clk;
    input mode_in, state_in;
    input clk_1, clk_10, clk_100;
    input rst;
    output state_LED, mode_LED;
    output [3:0]ssd_ctl;
    output [7:0]D_ssd;
    wire state_deb_out, state_onePulse_out;
    wire mode_deb_out, mode_onePulse_out;
    wire count_enable;
    wire [3:0]out0, out1, out2, out3;
    wire [3:0]ssd_in;
    wire point;
    
    reg [3:0]freeze_0, freeze_1, freeze_2, freeze_3;
    reg [3:0]disp_0, disp_1, disp_2, disp_3;
    reg increase;
    
    
     always @*
        if((disp_0 == 9 && disp_1 == 5 && disp_2 == 9 && disp_3 == 5) || count_enable == 0)
             increase = 0;
        else
             increase = 1;
    

    
   debounce U1(
      .clk(clk_100), // clock control
      .rst(rst), // reset
      .pb_in(state_in), //push button input
      .pb_debounced(state_deb_out) // debounced push button output
    );
    
    one_pulse U3(
      .clk(clk_1),  // clock input
      .rst(rst), //active low reset
      .in_trig(state_deb_out), // input trigger
      .out_pulse(state_onePulse_out) // output one pulse 
    );
    
    state_FSM U6(
    .count_enable(count_enable), // if counter is enabled
    .in(state_onePulse_out), //input control
    .clk(clk_1), // global clock signal
    .rst(rst), // high active reset
    .state(state_LED)
    );
    
     mode_debounce U4(
     .clk(clk_100), // clock control
     .rst(rst), // reset
     .pb_in(mode_in), //push button input
     .pb_debounced(mode_deb_out) // debounced push button output
   );
   
   
    mode_one_pulse U5(
        .clk(clk_1),  // clock input
        .rst(rst), //active low reset
        .in_trig(mode_deb_out), // input trigger
        .out_pulse(mode_onePulse_out) // output one pulse 
    );
    
    Lap_FSM U7(
    .in(mode_onePulse_out), //input control
    .clk(clk_1), // global clock signal
    .rst(rst), // high active reset
    .state(mode_LED)
    );
    
    stopwatch U8(
        .clk(clk_10),
        .increase(increase),
        .rst(rst),
        .out3(out3),
        .out2(out2),
        .out1(out1),
        .out0(out0)
        );
    always @(posedge mode_LED)
        freeze_0 <= out0;
    always @(posedge mode_LED)
        freeze_1 <= out1;
    always @(posedge mode_LED)
        freeze_2 <= out2;
    always @(posedge mode_LED)
        freeze_3 <= out3; 
    always @*
        if(mode_LED)
            begin
                disp_0 = freeze_0;
                disp_1 = freeze_1;
                disp_2 = freeze_2;
                disp_3 = freeze_3;
            end
        else
            begin
                disp_0 = out0;
                disp_1 = out1;
                disp_2 = out2;
                disp_3 = out3;
            end
            
     scan_ctl U10(
      .ssd_ctl(ssd_ctl), // ssd display control signal 
      .ssd_in0(disp_0), // output to ssd display
      .ssd_in1(disp_1),
      .ssd_in2(disp_2),
      .ssd_in3(disp_3),
      .ssd_in(ssd_in),
      .ssd_ctl_clk(ssd_clk),
      .point(point),  
      .rst(rst)   // reset
    );
    
    Display_7_segment U11(.D_ssd(D_ssd), .i(ssd_in), .point(point));

        
endmodule
