`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/30/2020 03:10:47 PM
// Design Name: 
// Module Name: Lab5_3
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab6_2(
    clk_1,
    clk_10,
    clk_100,
    pause_pb,
    stop_pb,
    state_LED,
    mode_LED,
    ssd_ctl,
    D_ssd,
    ssd_clk,
    LED,
    setting,
    rst,
    mode6_1_or_6_2
    );
    
    input mode6_1_or_6_2;
    input rst;
    input setting;
    input pause_pb, stop_pb;
    input clk_1, clk_10, clk_100;
    input [1:0]ssd_clk;
    output state_LED;
    output mode_LED;
    output [3:0]ssd_ctl;
    output [7:0]D_ssd;
    output reg [9:0]LED;
    wire min_deb;
    wire sec_deb;
    wire pause_deb_out, pause_onePulse_out;
    wire stop_deb_out, stop_onePulse_out;
    wire count_enable;
    wire [3:0]min_set0, min_set1, sec_set0, sec_set1;
    wire [3:0]ssd_in;
    wire point;
    wire min_add, sec_add;
    wire start;
    
    wire [3:0]ti_out0, ti_out1, ti_out2, ti_out3;
    reg [3:0]tmp0, tmp1, tmp2, tmp3;
    reg [3:0]disp_0, disp_1, disp_2, disp_3;
    reg decrease;
    reg start_rst, start_state;
    
     always @*
        if((disp_0 == 0 && disp_1 == 0 && disp_2 == 0 && disp_3 == 0) || count_enable == 0 ||  (~start) || setting)
             decrease = 0;
        else
             decrease = 1;
     always @*
        if(disp_0 == 0 && disp_1 == 0 && disp_2 == 0 && disp_3 == 0 && mode6_1_or_6_2)
            LED = 10'b1111_1111_11;
        else
            LED = 10'd0;
            
    
     min_debounce U1(
     .clk(clk_100), // clock control
     .rst(rst), // reset
     .pb_in(pause_pb), //push button input
     .pb_debounced(min_deb) // debounced push button output
     );
     
    assign min_add = setting & min_deb;
     
    min U2(
    .clk(clk_10),
    .increase(min_add),
    .reset(rst),
    .out1(min_set1),
    .out0(min_set0)
    );
    
     sec_debounce U3(
     .clk(clk_100), // clock control
     .rst(rst), // reset
     .pb_in(stop_pb), //push button input
     .pb_debounced(sec_deb) // debounced push button output
     );
     
     assign sec_add = setting & sec_deb;
     
     sec U4(
     .clk(clk_10),
     .increase(sec_add),
     .rst(rst),
     .out1(sec_set1),
     .out0(sec_set0)
     );
     
     
      Timer_4d U5(
         .out0(ti_out0),
         .out1(ti_out1),
         .out2(ti_out2),
         .out3(ti_out3),
         .set0(sec_set0),
         .set1(sec_set1),
         .set2(min_set0),
         .set3(min_set1),
         .decrease(decrease),
         .clk(clk_10),
         .setting(setting),
         .rst(start_rst)
         );
         
     pause_debounce U6(
       .clk(clk_100), // clock control
       .rst(rst), // reset
       .pb_in(pause_pb), //push button input
       .pb_debounced(pause_deb_out) // debounced push button output
     );
     pause_one_pulse U7(
       .clk(clk_1),  // clock input
       .rst(rst), //active low reset
       .in_trig(pause_deb_out), // input trigger
       .out_pulse(pause_onePulse_out) // output one pulse 
     );
     
     pause_FSM U8(
     .count_enable(count_enable), // if counter is enabled
     .in(pause_onePulse_out), //input control
     .clk(clk_1), // global clock signal
     .rst(rst), // high active reset
     .state(state_LED)
     );
     
     stop_debounce U9(
       .clk(clk_100), // clock control
       .rst(rst), // reset
       .pb_in(stop_pb), //push button input
       .pb_debounced(stop_deb_out) // debounced push button output
     );
     
    stop_one_pulse U11(
    .clk(clk_1),  // clock input
    .rst(rst), //active low reset
    .in_trig(stop_deb_out), // input trigger
    .out_pulse(stop_onePulse_out) // output one pulse 
    );
    
    stop_FSM U12(
    .count_enable(start), // if counter is enabled
    .in(stop_onePulse_out), //( control
    .clk(clk_1), // global clock signal
    .rst(rst), // high active reset
    .state(mode_LED)
    );
    always @(posedge clk_10)
        start_state <= mode_LED;
    always @*
        if(~start_state && stop_onePulse_out)
            start_rst = 1'b1;
        else
            start_rst = 1'b0;

    /*
    always @(negedge mode_LED)
        tmp0 <= disp_0;
    always @(negedge mode_LED)
        tmp1 <= disp_1;
    always @(negedge mode_LED)     
        tmp2 <= disp_2;
    always @(negedge mode_LED)     
        tmp3 <= disp_3;
     */
    always @*
        if(setting == 0)
            begin
                disp_0 = ti_out0;
                disp_1 = ti_out1;
                disp_2 = ti_out2;
                disp_3 = ti_out3;
            end
        else
            begin
                disp_0 = sec_set0;
                disp_1 = sec_set1;
                disp_2 = min_set0;
                disp_3 = min_set1;
            end    
            
     scan_ctl U10(
      .ssd_ctl(ssd_ctl), // ssd display control signal 
      .ssd_in0(disp_0), // output to ssd display
      .ssd_in1(disp_1),
      .ssd_in2(disp_2),
      .ssd_in3(disp_3),
      .ssd_in(ssd_in),
      .ssd_ctl_clk(ssd_clk),
      .point(point)
    );
   
    Display_7_segment U13(.D_ssd(D_ssd), .i(ssd_in), .point(point));

        
endmodule
