`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/30/2020 01:52:15 PM
// Design Name: 
// Module Name: Timer60
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Timer_4d(
    out0,
    out1,
    out2,
    out3,
    set0,
    set1,
    set2,
    set3,
    decrease,
    clk,
    rst,
    stop,
    setting
    );
    output [3:0]out0, out1, out2, out3;
    input [3:0]set0, set1,set2, set3, setting, rst; 
    input decrease, clk, stop;
    wire borrow2_3, borrow1_2, borrow0_1;
   
    Timer_4d_digit3 U3(
    .value(out3), // counter output
    .decrease(borrow2_3), // borrow indicator
    .clk(clk), // global clock
    .setting(setting), // active low reset
    .set(set3),
    .stop(stop),
    .rst(rst)
    );
    
    Timer_4d_digit2 U2(
    .value(out2), // counter output
    .decrease(borrow1_2), // borrow indicator
    .clk(clk), // global clock
    .setting(setting), // active low reset
    .borrow(borrow2_3),
    .set(set2),
    .stop(stop),
    .rst(rst)
    );
    Timer_4d_digit1 U1(
    .value(out1), // counter output
    .decrease(borrow0_1), // borrow indicator
    .clk(clk), // global clock
    .setting(setting), // active low reset
    .borrow(borrow1_2),
    .set(set1),
    .stop(stop),
    .rst(rst)
    );
    
    Timer_4d_digit0 U0(
    .value(out0), // counter output
    .borrow(borrow0_1), // borrow indicator
    .clk(clk), // global clock
    .decrease(decrease),
    .set(set0),
    .stop(stop),
    .setting(setting),
    .rst(rst)
    );
    
endmodule
